image: bash:5.2.26-alpine3.19

variables:
  RUNNER_GENERATE_ARTIFACTS_METADATA: "false"
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
  CS_IMAGE: "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}"

stages:
  - build
  - test
  - review
  - deploy
  - iot-deploy

build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:v1.9.0-debug
    entrypoint: [""]
  script:
    - /kaniko/executor
      --context "${CI_PROJECT_DIR}"
      --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
      --destination "${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHA}"

test-code-job:
  stage: test
  script:
    - echo "If the files are built successfully, test some files with one command:" 
  needs: []

win:build:
 stage: build
 before_script:
   - echo "First I go"
 script:
   - echo "Then me inthe midle"
   - echo "A Windows exe as Artifact" > artifact-text.txt
 after_script:
   - echo "Then me at the end"
   - sleep 15
 artifacts:
   paths:
     - artifact-text.txt
   expire_in: 1 hour


win:test:
 stage: test
 needs: ["win:build"]
 image: alpine:3.19.0
 before_script:
   - pwd
   - ls -la
 script:
   - whoami
   - cat artifact-text.txt
 after_script:
   - echo "Win is tested!"

PyPa:build:
  stage: build
  image: python:slim-bullseye
  cache:
    paths:                    # https://pip.pypa.io/en/stable/topics/caching/
      - .cache/pip
  before_script:
    - python -V              
    - pip install virtualenv
    - virtualenv venv
  script:
    - pip install -r requirements.txt 
    - echo "Building the Python Package..."

PyPa:test:
  stage: test
  needs: ["PyPa:build"]
  image: python:slim-bullseye
  cache:
    paths:                    # https://pip.pypa.io/en/stable/topics/caching/
      - .cache/pip
  before_script:
    - python -V
    - pip install virtualenv
    - virtualenv venv
  script:
    - pip install -r requirements.txt 
    - echo "Running test in python..."

linux:build:
  stage: build
  script: 
    - echo "Building linux..."
    - sleep 5

linux:test:
  stage: test
  needs: ["linux:build"]
  script: echo "Running rspec on linux..."

mac:build:
  stage: build
  script: 
    - echo "Building mac..."
    - sleep 10

mac:test:
  stage: test
  needs: ["mac:build"]
  script: echo "Running rspec on mac..."
    
lint:
  stage: test
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      allow_failure: true
  needs: []
  script: 
    - echo "Linting..." 

production:
  stage: deploy
  needs: ["mac:test", "linux:test", "win:test"]
  script: echo "Running production..."
  environment: production

PyPa:package:
  stage: deploy
  needs: ["PyPa:test"]
  image: python:slim-bullseye
  cache:
    paths:                    # https://pip.pypa.io/en/stable/topics/caching/
      - .cache/pip
  before_script:
    - python -V
    - pip install virtualenv
    - virtualenv venv
  script:
    - pip install -r requirements.txt 
    - echo "Packaging and publishing the Python Package"

deploy review:
  stage: review
  script:
    - echo "Do your average deploy here"
  rules:
    - if: '$CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH'
      when: never
    - if: '$CI_COMMIT_TAG'
      when: never
    - when: always
  environment:
    name: review/$CI_COMMIT_REF_NAME

deploy release:
  stage: deploy
  script:
    - echo "Deploy to a production environment"
  rules:
    - if: '$CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH && $CI_COMMIT_TAG'
      when: manual
  environment:
    name: production

deploy staging:
  stage: deploy
  script:
    - echo "Deploy to a staging environment"
  rules:
    - if: '$CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH'
      when: always
    - when: never
  environment:
    name: staging

deploying_to_iot:
  stage: iot-deploy
  needs: ["production"]
  trigger:
    include:
          - local: iot/iot.gitlab-ci.yml